
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>数塔DP / 憋错料</title>

    <meta name="description" content="数塔DP 在讲述DP算法的时候,一个经典的例子就是数塔问题,它是这样描述的: 有如下所示的数塔,要求从顶层走到底层,若每一步只能走到相邻的结点,则经过的结点的数字之和最大是多少? 已经告诉你了,这是个DP的题目,你能AC吗? Input 输入数据首先包括一个整数C,表示测试实例的个数,每个测试实例的第一行是一个整数N(1 &lt;= N &lt;= 100),表示数塔的高度,接下来用N行数字表示数塔,其中第i行有个i个整数,且所有的整数均在区间[0,99]内. Output 对于每个测试实例,输出可能得到 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">数塔DP</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在讲述DP算法的时候，一个经典的例子就是数塔问题，它是这样描述的：</p>
<p>有如下所示的数塔，要求从顶层走到底层，若每一步只能走到相邻的结点，则经过的结点的数字之和最大是多少？</p>
<p>已经告诉你了，这是个DP的题目，你能AC吗?</p>
<p>Input</p>
<p>输入数据首先包括一个整数C,表示测试实例的个数，每个测试实例的第一行是一个整数N(1 &lt;= N &lt;= 100)，表示数塔的高度，接下来用N行数字表示数塔，其中第i行有个i个整数，且所有的整数均在区间[0,99]内。</p>
<p>Output</p>
<p>对于每个测试实例，输出可能得到的最大和，每个实例的输出占一行。</p>
<p>Sample Input</p>
<p>1</p>
<p>5</p>
<p>7</p>
<p>3 8</p>
<p>8 1 0</p>
<p>2 7 4 4</p>
<p>4 5 2 6 5</p>
<p>Sample Output</p>
<p>30</p>
<pre>#include &lt;stdio.h&gt;
int main()
{
	int c,i,j;
	int dp[105][105];
	scanf(&quot;%d&quot;,&amp;c);
	while(c--)
	{
		int n;
		scanf(&quot;%d&quot;,&amp;n);
		for(i=1;i&lt;=n;i++)
			for(j=1;j&lt;=i;j++)
			{
				scanf(&quot;%d&quot;,&amp;dp[i][j]);
			}
			for(i=n;i&gt;=2;i--)
			{
				for(j=1;j&lt;n;j++)
				{
					if(dp[i][j]&gt;dp[i][j+1])
					{
						dp[i-1][j]+=dp[i][j];
					}
					else
					{
						dp[i-1][j]+=dp[i][j+1];
					}
				}
			}
			printf(&quot;%d\n&quot;,dp[1][1]);
	}
	return 0;
}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 16:39:12 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/printf/" title="printf">printf</a>, <a href="https://www.biecuoliao.com/tag/amp/" title="amp">amp</a>, <a href="https://www.biecuoliao.com/tag/acm%e7%ae%97%e6%b3%95/" title="acm算法">acm算法</a>, <a href="https://www.biecuoliao.com/tag/math-h/" title="math&period;h">math&period;h</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>数塔DP的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rZWzX3.html" rel="bookmark">HDU 2048 数塔&lpar;DP&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数塔 Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 20786    Accepted Submission(s): 12486 Problem Description 在讲述DP算法的时候,一个经典的例子就是数塔问题,它是这样描述的: 有如下所示的数塔,要求从顶层走到底层,若每一步只能走到相邻的结点,则经过的结点的数字之和最大是多少			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QvyXlM.html" rel="bookmark">hdu 2085 数塔  -- dp模板题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数塔 Problem Description 在讲述DP算法的时候,一个经典的例子就是数塔问题,它是这样描述的: 有如下所示的数塔,要求从顶层走到底层,若每一步只能走到相邻的结点,则经过的结点的数字之和最大是多少? 已经告诉你了,这是个DP的题目,你能AC吗? Input 输入数据首先包括一个整数C,表示测试实例的个数,每个测试实例的第一行是一个整数N(1 &lt;= N &lt;= 100),表示数塔的高度,接下来用N行数字表示数塔,其中第i行有个i个整数,且所有的整数均在区间[0,99]内. Outp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6yXNy4.html" rel="bookmark">HDU2391 Filthy Rich【数塔DP】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=2391 题目大意: 在一个N*M的矩阵中,不同的位置上有不同重量的黄金,从矩阵的左上角开始,只能向右 或是向下走,问:从左上角走到右下角最多能获得多少黄金. 思路: 简单的数塔DP,状态转移方程:dp[j] = max(dp[j-1],dp[j])+ Map[i][j]. AC代码: #include&lt;iostream&gt; #include&lt;algorithm&gt; #include&lt;			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDrrNp3.html" rel="bookmark">数塔~~dp学习&lowbar;1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2084 数塔 Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 32468    Accepted Submission(s): 19417 Problem Description 在讲述DP算法的时候,一个经典的例子就是数塔问题,它是这样描述的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xvOvk4.html" rel="bookmark">HDU 2084 数塔 &lpar;DP&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数塔 Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d &amp; %I64u Submit Status Practice HDU 2084 Description 在讲述DP算法的时候,一个经典的例子就是数塔问题,它是这样描述的: 有如下所示的数塔,要求从顶层走到底层,若每一步只能走到相邻的结点,则经过的结点的数字之和最大是多少? 已经告诉你了,这是个DP的题目,你能AC吗? Input 输入数据首先包括一个整数			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47Za9D3.html" rel="bookmark">POJ3176&lowbar;Cow Bowling【数塔DP】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Cow Bowling Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 14253 Accepted: 9461 Description The cows don't use actual bowling balls when they go bowling. They each take a number (in the range 0..99), though, and line up in a standard bowl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41aAYq4.html" rel="bookmark">hdu 2084 数塔 dp 动态规划</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开始动态规划的学习了,先是比较基础的,很金典的数塔.附上题目链接  http://acm.hdu.edu.cn/showproblem.php?pid=2084 这题的状态转移方程是  dp[i][j] = max(dp[i-1][j-1],dp[i-1][j]) + m[i][j]; (dp[i][j] 表示在第 i 层 第 j 列时的最大和) . 然后一个双重循环,边能算出.当然可以用滚动数组.但是注意用滚动数组解题时,第二层循环 j 必须从大到小, 因为 状态转移方程 为  f  [ j			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qKeOGM.html" rel="bookmark">USACO training course Number Triangles 数塔 &sol;&sol;&sol; DP oj10122</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目大意: ...就是数塔       7         3   8      8   1   0     2   7   4   4 4   5   2   6   5 7+3+8+7+5=30 Sample Input 573 88 1 02 7 4 44 5 2 6 5 212 3 Sample Output 304 DP水题 记录一下 自下往上走 左右始终选择较大的与之上的相加 #include&lt;iostream&gt; #include&lt;algorithm&gt; #include			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OZkAr0.html" rel="bookmark">hdu2084 数塔 DP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数字三角形,DP裸题 1 #include&lt;stdio.h&gt; 2 #include&lt;string.h&gt; 3 #define max(a,b) (a)&gt;(b)?a:b 4 5 int g[101][101],dp[101][101]; 6 7 int max1(int i,int j){ 8 return i&gt;j?i:j; 9 } 10 11 int main(){ 12 int C; 13 while(scanf(&quot;%d&quot;,&amp;C)!=EOF)			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xQEj3.html" rel="bookmark" class="title">springMVC简单例子</a>
					<div>
						spring MVC是显示层的mvc框架,和struts可以比较:和spring.hibernate没有比较性. 一 .开发流程 1)引jar包 //spring_core spring3.2.9co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V0brBw0.html" rel="bookmark" class="title">LVS&comma;Nginx&comma;HAProxy简单对比</a>
					<div>
						LVS,Nginx,HAProxy 作为负载均衡器对比 LVS:     优点:         负载均衡能力强,工作在4层(内核中)         稳定,配置简单         应用范围广    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47pqmRM.html" rel="bookmark" class="title">利用&period;htaccess绑定子域名到子目录（亲测万网可用）</a>
					<div>
						http://www.xmgho.com/archives/783.html 利用.htaccess绑定域名到子目录,前提你的空间服务器必须支持apache的rewrite功能,只有这样才能使用.ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQrZN3.html" rel="bookmark" class="title">Java语言中反射动态代理接口的解释与演示</a>
					<div>
						Java语言中反射动态代理接口的解释与演示 Java在JDK1.3的时候引入了动态代理机制.可以运用在框架编程与平台编程时候捕获事件.审核数据.日志等功能实现,首先看一下设计模式的UML图解: 当你调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vEleZ0.html" rel="bookmark" class="title">DotNET知识点总结四（笔记整合）</a>
					<div>
						1.枚举:本质是类 如果为第一个枚举赋了一个int值,那么后面的枚举项依次递增 可以将枚举强转成他所代表的int值 C#的枚举项都是常量(可以用Reflector查看literal的IL源码) 因为枚 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q5gyD3.html" rel="bookmark" class="title">IOS研究之App转让流程须知详细介绍</a>
					<div>
						﻿﻿ 网络上有很多开发者提问怎么转让App并想知道具体的流程.实际上Appstore的App转让流程还是比较简单的,下面特酷吧根据自己的实际操作总结下iOS Appstore中App的转让流程,供大家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Am8VK4.html" rel="bookmark" class="title">C&num; GetValueList 获得字符串中开始和结束字符串中间得值列表</a>
					<div>
						/// &lt;summary&gt; /// 获得字符串中开始和结束字符串中间得值列表 /// &lt;/summary&gt; /// &lt;param name=&quot;styleCont ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Amw9v4.html" rel="bookmark" class="title">关于scanf与cin哪个快的问题</a>
					<div>
						一开始入c++的时候成天跑cin,cout 直到有一天用cin,cout超时 才知道scanf比cin快的多 但是后来又听说加了ios::sync_with_stdio(false);的cin跟飞一样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgPReL0.html" rel="bookmark" class="title">多校第五场</a>
					<div>
						5783.Divide the Sequence 题意:给出一段序列,尽可能多得分割序列使得每段前缀和非负. 分析:既然前缀和非负,那么从后往前遍历,若非负则++. #include &lt;stdi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KBGNKM.html" rel="bookmark" class="title">软件开发不能用建筑开发来比喻</a>
					<div>
						多年以来,软件行业一直在使用一种类比,即以建筑行业来做参考和比喻.这种比较在软件语言里随处可见,比如架构(architecture).地基(foundation).建造者(constructor).项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgZXQg4.html" rel="bookmark" class="title">手机访问自动跳转</a>
					<div>
						$ua = strtolower($_SERVER['HTTP_USER_AGENT']); $uachar = &quot;/(nokia|sony|ericsson|mot|samsung|sgh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/382aXKM.html" rel="bookmark" class="title">从前慢</a>
					<div>
						&lt;从前慢&gt;——木心 记得早先少年时 大家诚诚恳恳 说一句 是一句   清早上火车站 长街黑暗无行人 卖豆浆的小店冒着热气   从前的日色变得慢 车,马,邮件都慢 一生只够爱一个人   从前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQjqPM.html" rel="bookmark" class="title">中国企业的平均寿命为何短暂&quest;</a>
					<div>
						数据显示,美国中小企业平均寿命不到7年,大企业平均寿命不足40年.而在中国,中小企业的平均寿命仅2.5年,集团企业的平均寿命仅7-8年.美国每年倒闭的企业约10万家,而中国则为100万家.失去寿命的企 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyBJoe0.html" rel="bookmark" class="title">HDU 1043 Eight &lpar;BFS&amp;&num;183&semi;八数码&amp;&num;183&semi;康托展开&rpar;</a>
					<div>
						题意  输出八数码问题从给定状态到12345678x的路径 用康托展开将排列对应为整数  即这个排列在所有排列中的字典序  然后就是基础的BFS了 #include &lt;bits/stdc++.h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1m6X3.html" rel="bookmark" class="title">小程序，wx&period;request；动态向服务器端请求数据。</a>
					<div>
						wx.request 通过微信封装的ajax,动态向服务器端请求数据.以下是在练习微信小程序时写的测试代码. 其中index.js文件如下 1 2 3 4 5 6 7 8 9 10 11 12 13  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXGZL84.html" rel="bookmark" class="title">手机锁机软件原理</a>
					<div>
						这两天在手机论坛里面发现好多手机被锁屏软件锁屏了,锁屏效果(模拟器中)如下: 初次接触这个软件,我一直以为是锁定了fastloader,但是问哪些被锁屏的人,他们没有root,也没有刷过机,只是单单的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MENwNx0.html" rel="bookmark" class="title">Java XML的总结（一）</a>
					<div>
						1.JAXP DOM * I --&gt; document * DocumentBuilderFactory --&gt; newInstance() * DocumentBuilder -- fa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d7lpzM.html" rel="bookmark" class="title">【原创】安装 MYSQL&lpar; AIX&rpar;</a>
					<div>
						本文以mysql-5.1.66-aix5.3-powerpc-64bit.tar.gz为例子 其中: mysql-5.1.66 : mysql版本 aix5.3 :AIX版本 powerpc :AIX ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02gVyo3.html" rel="bookmark" class="title">自定义view中自定义属性的用法&period;</a>
					<div>
						有时候我们自定义的view需要用到有自己定义的属性. 首先定义自己的属性,在res/values/attrs.xml中定义,xml文件如下: &lt;?xml version=&quot;1.0&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KKj9L0.html" rel="bookmark" class="title">java文件上传-原始的Servlet方式</a>
					<div>
						前言: 干了这几个项目,也做过几次文件上传下载,要么是copy项目以前的代码,要么是百度的,虽然做出来了,但学习一下原理弄透彻还是很有必要的.刚出去转了一圈看周围有没有租房的,在北京出去找房子是心里感 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
